{******************************************************************************}
{                                                                              }
{  eWriteAddresses.dpr                                                         }
{                                                                              }
{  Demonstrates how to use the LJM_eWriteAddresses function.                   }
{                                                                              }
{******************************************************************************}

program eWriteAddresses;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  LJMDelphi in '..\..\Wrapper\LJMDelphi.pas',
  LJMUtilities in '..\LJMUtilities.pas';

var
  i: Integer;
  Handle: Integer;
  Error: Integer;
  ErrorAddress: Integer;
  NumFrames: Integer;
  aAddresses: array [0..1] of Integer;
  aDataTypes: array [0..1] of Integer;
  aValues: array [0..1] of Double;
begin
  Handle := 0;

  { Open first found LabJack }

  { Any device, Any connection, Any identifier }
  Error := LJM_OpenS('Any', 'Any', 'Any', Handle);

  { T7 device, Any connection, Any identifier }
  { Error := LJM_OpenS('T7', 'Any', 'Any', Handle); }

  { T4 device, Any connection, Any identifier }
  { Error := LJM_OpenS('T4', 'Any', 'Any', Handle); }

  { Any device, Any connection, Any identifier }
  { Error := LJM_Open(LJM_dtAny, LJM_ctAny, 'Any', Handle); }

  ErrorHandler('LJM_OpenS', Error);

  { Display opened device's information. }
  PrintDeviceInfoFromHandle(Handle);

  { Call LJM_eWriteAddresses to write multiple values to the LabJack. }
  NumFrames := 2;
  aAddresses[0] := 1000; { DAC0 }
  aAddresses[1] := 55110; { TEST_UINT16 }
  aDataTypes[0] := LJM_FLOAT32;
  aDataTypes[1] := LJM_UINT16;
  aValues[0] := 2.5; { V }
  aValues[1] := 12345;
  ErrorAddress := -1;
  Error := LJM_eWriteAddresses(Handle, NumFrames, @aAddresses, @aDataTypes,
    @aValues, ErrorAddress);
  ErrorHandler('LJM_eWriteAddresses', Error, ErrorAddress);

  Writeln('LJM_eWriteAddresses:');
  for i := 0 to NumFrames-1 do
  begin
    Writeln('  Address = ' + IntToStr(aAddresses[i]) + ', Value = ' +
      FormatFloat('0.####', aValues[i]));
  end;

  { Close the handle. }
  Error := LJM_Close(Handle);
  ErrorHandler('LJM_Close', Error);

  WaitForUser('Press Enter to exit.');
end.
