{******************************************************************************}
{                                                                              }
{  SingleAIN.dpr                                                               }
{                                                                              }
{  Demonstrates reading a single analog input (AIN) from a LabJack.            }
{                                                                              }
{******************************************************************************}

program SingleAIN;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  LJMDelphi in '..\..\..\Wrapper\LJMDelphi.pas',
  LJMUtilities in '..\..\LJMUtilities.pas';

var
  Handle: Integer;
  Error: Integer;
  Name: AnsiString;
  Value: Double;
begin
  Handle := 0;

  { Open first found LabJack }

  { Any device, Any connection, Any identifier }
  Error := LJM_OpenS('Any', 'Any', 'Any', Handle);

  { T7 device, Any connection, Any identifier }
  { Error := LJM_OpenS('T7', 'Any', 'Any', Handle); }

  { T4 device, Any connection, Any identifier }
  { Error := LJM_OpenS('T4', 'Any', 'Any', Handle); }

  { Any device, Any connection, Any identifier }
  { Error := LJM_Open(LJM_dtAny, LJM_ctAny, 'Any', Handle); }

  ErrorHandler('LJM_OpenS', Error);

  { Display opened device's information. }
  PrintDeviceInfoFromHandle(Handle);

  { Setup and call LJM_eReadName to read from AIN0 on the LabJack. }
  Name := 'AIN0';
  Value := 0;
  Error := LJM_eReadName(Handle, PAnsiChar(Name), Value);
  ErrorHandler('LJM_eReadName', Error);

  Writeln(Name + ' = ' + FormatFloat('0.00000', Value) + ' V');

  { Close the handle. }
  Error := LJM_Close(Handle);
  ErrorHandler('LJM_Close', Error);

  WaitForUser('Press Enter to exit.');
end.
